#include<reg51f.h>
/*------------addressing control bit for lcd control----*/
sbit rs=P2^0; /*--pin 0 of port 2 is as a RS pin--*/
sbit rw=P2^1; /*---pin 1 of port 2 is as a RW pin--*/
sbit en=P3^0; /*-------pin 2 of port 2 is as a EN pin--*/
//---------------------------------------------------------------------//
//---------prototype declaration--------------------------------------//
void init_lcd();  //function use for lcd intialization---//
void lcd_comm(unsigned char value1); //-----function to send a command to lcd by refrance--//
void lcd_data(unsigned char value2); //-- function to send a data to lcd ------------------//
void lcd_msg(unsigned char *ch);   //------function to send a string to lcd ---------------//
void delay(unsigned int ms);       ///-----function for delay of ms------//

//--------------------------------------------------------------------//

//------------------main programe---------------------------------------//

void main()
{
	P0=0x00;   //------------intialzing Port 0 as putput port------------
	P2=0x00;  //------------intialzing Port 2 as putput port------------
	init_lcd(); //-----intialzing lcd for data transfer-----------------
	while (1)  //-------creating super loop-----------------------------
	{
		lcd_comm(0x80);  //--commmand send  to set cursor to the first location of first line ----
		lcd_msg("Harkesh Rawat");  //  send string to lcd for display----------------------------
		lcd_comm(0xC0);   //---------commmand send  to set cursor to the first location of second line ----
    delay(50);
		lcd_comm(0x18);   
		lcd_msg("Thankyou");  //  send string to lcd for display---------------------------- 		
	}
}
		//-----------------end super loop---------------------------------------------------
	void init_lcd()
	{
		lcd_comm(0x38);  //----------to select 16x2 line lcd display------------------------
		delay(10);       //--------delay of 10 ms ------------------------------------------
		lcd_comm(0x0E);  // setting display on and cursor as blinking-----------------------
		lcd_comm(0x01);  //------------clearing the lcd display----------------------------
		delay(10);       //--------------delay for 10 ms-----------------------------------
		lcd_comm(0x06);  //------auto increment cursor-------------------------------------
		delay(10);       //----delay for 10 ms --------------------------------------------
		lcd_comm(0x80);  //---------------setting first location of first line of lcd-----
		delay(10);       //----delay for 10 ms --------------------------------------------
	}

	void lcd_comm(	unsigned char value1)
	{
		P0=value1;    //--------------sending command to lcd from port P0----------------
		rs=0;         //---------rs=resistor select pin ,when (rs=0) means it command resistor ----
		rw=0;         //---------rw=read /write pin ,when (rw=0) means it write function ---------
		en=1;         //----en= enable pin , use to latch the data to lcd when it goes from high to low pulse ---
		delay(1);     //----delay for 1 ms ----------------------------------------------------
		en=0;
	}		
	
	void lcd_data(	unsigned char value2)
	{
		P0=value2;    //--------------sending command to lcd from port P0----------------//
		rs=1;         //---------rs=resistor select pin ,when (rs=0) means it data resistor ----//
		rw=0;         //---------rw=read /write pin ,when (rw=0) means it write function ---------//
		en=1;         //----en= enable pin , use to latch the data to lcd when it goes from high to low pulse ---
		delay(1);     //------------------------delay for 1 ms -------------------------
		en=0;
	}		
		
	void lcd_msg(unsigned char *ch)
	{
		while (*ch != 0)   //----creating super loop with conditing that ch pointer pointing data address ie not equal to zero---			
		{
			
			lcd_data(*ch);
			ch++;
		}
	}
		void delay(unsigned int ms)
	{
		unsigned int i,j;
		for(i=0;i<=ms;i++)  //-------------nop operation till the loop execution is complete------
		for (j=0;j<=120;j++);  //----nop operation till the loop execution is complete------ 	
	}
	